using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Syncfusion.XlsIO;
using System.Data.SqlClient;

public partial class Reports_DLSDownload : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (Request.QueryString["Report"] == null || Request.QueryString["Report"].ToString() == "")
        {
            Response.Write("<font color='red'>Invalid Download</font>");
        }
        else
        {
            fnDownLoadDLS(Request.QueryString["Report"].ToString());
        }
    }

    private void fnDownLoadDLS(string DLSRefNo)
    {
        ExcelEngine excelEngine = new ExcelEngine();
        IApplication application = excelEngine.Excel;
        IWorkbook workbook = excelEngine.Excel.Workbooks.Open(Server.MapPath(@"..\Template\DefectLogging.xls"));       
        IWorksheet sheet = workbook.Worksheets[0];
        string fileName = "DLS.xls";
        application.ArgumentsSeparator = ';';
        application.RowSeparator = ':';
        CreateTemplate(sheet, DLSRefNo);

        //workbook.SaveAs(fileName,ExcelSaveType.SaveAsXLS, Response, ExcelDownloadType.PromptDialog,ExcelHttpContentType.Excel2007);
        //No exception will be thrown if there are unsaved workbooks. No use here since we are
        //saving the workbook.
        //workbook.Close();
        //excelEngine.ThrowNotSavedOnDestroy = false;
        //excelEngine.Dispose();
            workbook.ActiveSheetIndex = 0;
            workbook.SaveAs(fileName, Response, ExcelDownloadType.PromptDialog);
            workbook.Close();
            
            excelEngine.Dispose();
    }

    private void CreateTemplate(IWorksheet ws,string DLSRefNo)
    {
        string strqry = string.Empty;
        strqry = @"Select UserId,ProjectId,ProjectName,DocumentName,Version,ReviewType, ReviewSource,ReviewSource,ODC as ProjectPhase,AuthorName, 
                    Cast(DatePart(dd,Convert(DateTime,PlannedDate,103)) as varchar) + '-' + Substring(DATENAME(m,Convert(DateTime,PlannedDate,103)),1,3) + '-' + Cast(DatePart(yyyy,Convert(DateTime,PlannedDate,103)) as varchar) as PlannedDate,
                    Cast(DatePart(dd,Convert(DateTime,ReviewDate,103)) as varchar) + '-' + Substring(DATENAME(m,Convert(DateTime,ReviewDate,103)),1,3) + '-' + Cast(DatePart(yyyy,Convert(DateTime,ReviewDate,103)) as varchar) as ReviewDate, RevPTime, RevTimeSpent, RewTimeSpent, FileBData
                    from DLSReportingData A Left Outer Join ODC B on A.ProjectPhase = B.ID where UniqueId = '" + DLSRefNo + @"'";

        SqlDataReader SqlRd = Common.ResultSet(strqry);

        string UserId = string.Empty;
        string ProjectId = string.Empty;
        string ProjectName = string.Empty;
        string DocumentName = string.Empty;
        string Version = string.Empty;
        string ReviewType = string.Empty;
        string ReviewSoruce = string.Empty;
        string ProjectPhase = string.Empty;
        string AuthorName = string.Empty;
        string PlannedDate = string.Empty;
        DateTime ReviewDate = new DateTime();
        string RevPTime = string.Empty;
        string RevTimeSpent = string.Empty;
        string RewTimeSpent = string.Empty;

        string Contents = "";
        const int ChunkSize = 1024 * 5000;
        //byte[] buffer = new byte[ChunkSize];

        if (SqlRd.Read())
        {
            UserId = SqlRd["UserId"].ToString();
            ProjectId = SqlRd["ProjectId"].ToString();
            ProjectName = SqlRd["ProjectName"].ToString();
            DocumentName = SqlRd["DocumentName"].ToString();
            Version = SqlRd["Version"].ToString();
            ReviewType = SqlRd["ReviewType"].ToString();
            ReviewSoruce = SqlRd["ReviewSource"].ToString();
            ProjectPhase = SqlRd["ProjectPhase"].ToString();
            AuthorName = SqlRd["AuthorName"].ToString();
            PlannedDate = SqlRd["PlannedDate"].ToString();
            ReviewDate = Convert.ToDateTime(SqlRd["ReviewDate"].ToString());
            RevPTime = SqlRd["RevPTime"].ToString();
            RevTimeSpent = SqlRd["RevTimeSpent"].ToString();
            RewTimeSpent = SqlRd["RewTimeSpent"].ToString();
            
            byte[] binary = (SqlRd["FileBData"]) as byte[];
            Contents = Common.ConvertByteArrayToString(binary).TrimStart().TrimEnd();
        }

        ws.Range["D2"].Text = AuthorName;
        ws.Range[2, 7].DateTime = ReviewDate;
        ws.Range["D3"].Text = DocumentName;
        ws.Range["D4"].Text = Version;
        ws.Range["D5"].Text = Common.fnGetUserName(UserId);

        //Admin Info

        ws.Range[1, 27].Text = ProjectId;
        ws.Range[2, 27].Text = ProjectName;
        ws.Range[3, 27].Text = ReviewSoruce;
        ws.Range[4, 27].Text = PlannedDate;
        ws.Range[5, 27].Text = "1";
        ws.Range[6, 27].Text = RevPTime;
        ws.Range[7, 27].Text = RevTimeSpent;
        ws.Range[8, 27].Text = "";
        ws.Range[9, 27].Text = AuthorName;
        ws.Range[10, 27].Text = ReviewType;
        ws.Range[11, 27].DateTime = ReviewDate;
        ws.Range[12, 27].Text = ProjectPhase;
        ws.Range[13, 27].Text = RewTimeSpent;
        ws.Range[13, 29].Text = Common.fnGetUserEmpNo(UserId); ;

        Contents = Contents.Substring(Contents.LastIndexOf("`") + 1);

        string[] CommentsLBL = Contents.Split('\n');

        //Comments Type
        fnGetODC(CommentsLBL[0],"1", "30", ref ws);

        // Defect Type
        fnGetODC(CommentsLBL[0], "2", "32", ref ws);

        //State of Origin
        fnGetODC(CommentsLBL[0], "3", "34", ref ws);

        //Defect Qualifier
        fnGetODC(CommentsLBL[0], "5", "36", ref ws);

        //Cause of Defect
        fnGetODC(CommentsLBL[0], "4", "38", ref ws);

        //Status 
        fnGetStatus(CommentsLBL[0], "7", "40", ref ws);

        //ReviewResult 
        fnGetStatus(CommentsLBL[0], "8", "41", ref ws);

        //Loading Defect List

        int Index = 0;
        int RowIndex = 13;
        foreach (string strDefect in CommentsLBL)
        {
            if (Index > 0)
            {
                string[] Defects = strDefect.Split('~');
                ws.Range[RowIndex, 1].Text = Index.ToString();

                for (int i = 1; i < Defects.Length; i++)
                {
                    if ((i + 1) > 5)
                    {
                        //if (string.IsNullOrEmpty(Defects[i]))
                        //    ws.Range[RowIndex, i + 2].Text = "-";
                        //else
                            ws.Range[RowIndex, i + 2].Text = Defects[i].ToString().TrimStart().TrimEnd().Replace("\0", "");
                    }
                    else
                    {
                        //if (string.IsNullOrEmpty(Defects[i]))
                        //    ws.Range[RowIndex, i + 1].Text = "-";
                        //else
                            ws.Range[RowIndex, i + 1].Text = Defects[i].ToString().TrimStart().TrimEnd().Replace("\0", "");
                    }
                }

                RowIndex++;
            }
            Index++;
        }

        SqlRd.Close();
    }

    private void fnGetStatus(string Parm, string ODCId, string colNum, ref IWorksheet ws)
    {
        string strqry = string.Empty;

        strqry = "Select Id,ODC from ODC where ODCId = '" + ODCId + "' and IsActive = 1";

        SqlDataReader SqlRd = Common.ResultSet(strqry);

        int RowIndex = 1;
        while (SqlRd.Read())
        {
            ws[RowIndex, Convert.ToInt16(colNum)].Text = SqlRd["ODC"].ToString();
            RowIndex++;
        }

        SqlRd.Close();
    }
    

    private void fnGetODC(string Parm, string ODCId, string colNum, ref IWorksheet ws)
    {
        string strqry = string.Empty;

        if (Parm.Contains("STD:STD"))
        {
            strqry = "Select Id,ODC from ODC where ODCId = '" + ODCId + "' and IsActive = 1";
        }
        else
        {
            string[] ProjId = Parm.Split(':');
            strqry = @"Select ProductSector, BUProj, Id,ODC from (
                    Select ProductSector,BUProj = isNull(ProjectId,BusinessUnit),B.Id, ODC from ODCMapping A
                    Inner Join ODC B on A.ODCID = B.Id and B.IsActive = 1
                    where A.IsActive = 1 and B.ODCId = '" + ODCId + @"' 
                    ) A where BUProj = '" + ProjId[1].ToString() + @"'
                    Order By Id";
        }

        SqlDataReader SqlRd = Common.ResultSet(strqry);

        int RowIndex = 1;
        while (SqlRd.Read())
        {
            ws[RowIndex, Convert.ToInt16(colNum)].Text = SqlRd["Id"].ToString();
            ws[RowIndex, Convert.ToInt16(colNum)+1].Text = SqlRd["ODC"].ToString();
            RowIndex++;
        }

        SqlRd.Close();
    }
}
